<?php

    require_once './system/common.php';
    require_once './system/functions.php';
    require_once './system/user.php';

    if ( !$user || $user['access'] <= 2 ) {
        header('Location: /');
        exit;
    }

    $title = 'Купоны';
    require_once './system/h.php';

    $act = isset($_GET['act']) && !empty($_GET['act']) ? trim($_GET['act']) : false;

    if ( isset($_SESSION['alert']) ) {
        echo $_SESSION['alert'];
        unset($_SESSION['alert']);
    }

    echo '<div class="content">';

    switch ( $act ) {
        default:
            echo '<div class="block center s125 color3">
            <a href="/tb2021">Панель</a>/ Купоны
            </div>
            <div class="line"></div>
            <div class="menu">
            <li><a href="?act=create"><img src="/images/icons/plus.png" width="16px" height="16px" alt=""> Создать купон</a></li>
            <li><a href="?act=active-coupons"><img src="/images/icons/sub_forum_0.png" width="16px" height="16px" alt=""> Активные купоны</a></li>
            </div>';
        break;
        case 'create':
            function gen_password ( $length = 6 ) {				
                $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
                return substr(str_shuffle($chars), 0, $length);
            }
            if ( isset($_POST['formCoupons']) && !empty($_POST['formCoupons']) ) {
                $formCoupons = $_POST['formCoupons'];
                $code        = _string($formCoupons['code']);
                $use         = _string($formCoupons['use']);
                $time        = _string($formCoupons['time']);
                $silver      = _string($formCoupons['silver']);
                $gold        = _string($formCoupons['gold']);
                $donate      = _string($formCoupons['donate']);
                $item_id     = _string($formCoupons['item_id']);
                $check_code  = mysql_fetch_assoc(mysql_query('SELECT `code` FROM `coupons` WHERE `code` = "'.$code.'" AND `time` > '.time()));
                if ( $check_code ) {
                    $_SESSION['errors'][0] = 'Такой код уже существует';
                }
                $i = -1;
                foreach ( $formCoupons as $key => $data ) { $i++;
                    if ( !$formCoupons[$key] ) {
                        $_SESSION['errors'][$i] = 'Необходимо заполнить поле';
                    }
                    if ( $i == 2 ) {
                        break;
                    }
                }
                $i = -1;
                foreach ( $formCoupons as $key => $data ) { $i++;
                    if ( $i >= 1 ) {
                        $formCoupons[$key] = intval( $formCoupons[$key] );
                    }
                }
                if ( !$silver && !$gold && !$donate && !$item_id ) {
                    for ( $i = 3; $i <= 6; $i++ ) {
                        $_SESSION['errors'][$i] = 'Одно из этих полей должно быть заполнено';
                    }
                }
                if ( isset($_SESSION['errors']) ) {
                    header('Location: ?act=create');
                    exit;
                }
                $time = ( time() + (86400 * $time) );
                mysql_query('INSERT INTO `coupons` (`code`, `use`, `time`, `silver`, `gold`, `donate`, `item_id`) VALUES ("'.$code.'", '.$use.', '.$time.', '.$silver.', '.$gold.', '.$donate.', '.$item_id.')');
                $_SESSION['alert'] = '<div class="alert">
                <img src="/images/icons/ok.png" width="16" height="16" alt=""> Купон успешно создан
                </div>
                <div class="alert_bottom"></div>';
                header('Location: ?');
                exit;
            }
            echo '<div class="block center s125 color3">
            <a href="?">Купоны</a>/ Создать купон
            </div>
            <div class="line"></div>
            <form action="?act=create" method="post" class="block">
            <div class="form-group field-text required '.( isset($_SESSION['errors'][0]) ? 'has-error' : false ).'">
            <label for="couponsCode">Код купона</label>
            <input class="form-control" type="text" id="couponsCode" name="formCoupons[code]" value="'.gen_password( 6 ).'">
            <div class="help-block">'.( isset($_SESSION['errors'][0]) ? $_SESSION['errors'][0] : false ).'</div>
            </div>
            <div class="form-group field-text required '.( isset($_SESSION['errors'][1]) ? 'has-error' : false ).'">
            <label for="couponsUse">Количество использований</label>
            <input class="form-control" type="number" id="couponsUse" name="formCoupons[use]" value="500">
            <div class="help-block">'.( isset($_SESSION['errors'][1]) ? $_SESSION['errors'][1] : false ).'</div>
            </div>
            <div class="form-group field-text required '.( isset($_SESSION['errors'][2]) ? 'has-error' : false ).'">
            <label for="couponsTime">Срок годности (дней)</label>
            <input class="form-control" type="number" id="couponsTime" name="formCoupons[time]" value="1">
            <div class="help-block">'.( isset($_SESSION['errors'][2]) ? $_SESSION['errors'][2] : false ).'</div>
            </div>
            <div class="form-group field-text required '.( isset($_SESSION['errors'][3]) ? 'has-error' : false ).'">
            <label for="couponsSilver">Рублей</label>
            <input class="form-control" type="number" id="couponsSilver" name="formCoupons[silver]" value="0">
            <div class="help-block">'.( isset($_SESSION['errors'][3]) ? $_SESSION['errors'][3] : false ).'</div>
            </div>
            <div class="form-group field-text required '.( isset($_SESSION['errors'][4]) ? 'has-error' : false ).'">
            <label for="couponsGold">Сахара</label>
            <input class="form-control" type="number" id="couponsGold" name="formCoupons[gold]" value="0">
            <div class="help-block">'.( isset($_SESSION['errors'][4]) ? $_SESSION['errors'][4] : false ).'</div>
            </div>
            <div class="form-group field-text required '.( isset($_SESSION['errors'][5]) ? 'has-error' : false ).'">
            <label for="couponsDonate">Сгущенки</label>
            <input class="form-control" type="number" id="couponsDonate" name="formCoupons[donate]" value="0">
            <div class="help-block">'.( isset($_SESSION['errors'][5]) ? $_SESSION['errors'][5] : false ).'</div>
            </div>
            <div class="form-group field-text required '.( isset($_SESSION['errors'][6]) ? 'has-error' : false ).'">
            <label for="couponsItem">Донатных рублей</label>
            <input class="form-control" type="number" id="couponsItem" name="formCoupons[item_id]" value="0">
            <div class="help-block">'.( isset($_SESSION['errors'][6]) ? $_SESSION['errors'][6] : false ).'</div>
            </div>
            <span class="m3 btn_start middle"><span class="btn_end"><button class="btn" type="submit">Создать купон</button></span></span>
            </form>
            <div class="dotted"></div>
            <ul class="block">
            <li class="small color2">Если стоит число 0 или пустое поле, эта строка не будет засчитываться.</li>
            </ul>';
        break;
        case 'active-coupons':
            $result = mysql_query('SELECT * FROM `coupons` WHERE `time` > '.time());
            while ( $row =  mysql_fetch_assoc($result) ) {
                echo '<div class="block">
                <div><img src="/images/icons/note.png" width="16" height="16" alt=""> Номер купона #'.$row['id'].'</div>
                <div>Срок годности: '._time($row['time'] - time()).'</div>
                <div>Код купона: '.$row['code'].'</div>
                <div>Осталось шт.: '.$row['use'].'</div>
                <div class="small"><a class="color2" href="?act=delete&id='.$row['id'].'">Удалить</a></div>
                </div>
                <div class="dotted"></div>';
            }
            echo '<div class="menu">
            <li><a href="?"><img src="/images/icons/back.png" width="16" height="16" alt=""> Вернуться назад</a></li>
            </div>';
        break;
        case 'delete':
            $id = isset($_GET['id']) && !empty($_GET['id']) ? intval($_GET['id']) : false;
            $check_coupons = mysql_fetch_assoc(mysql_query('SELECT `id` FROM `coupons` WHERE `id` = '.$id.' AND `time` > '.time()));
            if ( !$id || !$check_coupons ) {
                header('Location: ?act=active-coupons');
                exit;
            }
            if ( isset($_GET['yes']) ) {
                mysql_query('DELETE FROM `coupons` WHERE `id` = '.$id);
                $_SESSION['alert'] = '<div class="alert">
                <img src="/images/icons/ok.png" width="16" height="16" alt=""> Купон успешно удален
                </div>
                <div class="alert_bottom"></div>';
                header('Location: ?act=active-coupons');
                exit;
            }
            echo '<div class="block center s125 color3">
            <a href="?act=active_coupons">Активные купоны</a>/ Купон #'.$id.'
            </div>
            <div class="line"></div>
            <div class="block center s125 red">
            Вы действительно хотите удалить купон #'.$id.'?
            </div>
            <div class="dotted"></div>
            <div class="menu">
            <li><a href="?act=delete&id='.$id.'&yes"><img src="/images/icons/ok.png" width="16" height="16" alt=""> Да, подтверждаю</a></li>
            <li><a href="?act=active-coupons"><img src="/images/icons/cross.png" width="16" height="16" alt=""> Нет, отказываюсь</a></li>
            </div>';
        break;
    }

    echo '</div>';

    if ( isset($_SESSION['errors']) ) {
        unset($_SESSION['errors']);
    }

    require_once './system/f.php';
