<?php

include '../system/common.php';
include_once __DIR__ . '/sett.php';
include_once __DIR__ . '/WapkassaClass.php';

try {
    // Инициализация класса с id сайта и секретным ключом
    $wapkassa = new WapkassaClass(WK_ID, WK_SECRET);

    // Проверка обработчика (PING)
    if ($wapkassa->ping($_POST)) {
        // возврат успешной проверки
        echo $wapkassa->successPing();
    } else {
        // Парсинг входящих параметров
        $params = $wapkassa->parseRequest($_POST);

        $params['id']; // id платежа в системе wapkassa
        $params['site_id']; // id площадки
        $params['time']; // время оплаты в unixtime
        $params['comm']; // комментарий платежа
        $params['amount']; // сумма платежа
        $params['add']; // массив с допольнительными параметрами

        // собственный код зачисления платежа на сайте
        if ($params['add']['type'] == 'gold' && !empty($wk_cena_gold[$params['add']['count']]) && $wk_cena_gold[$params['add']['count']] <= $params['amount']) {
            $first_donate = mysql_fetch_assoc(mysql_query("SELECT `id` FROM `payments` WHERE `user` = '{$params["add"]["user_id"]}'"));
            if ($first_donate == false) $params['add']['count'] *= 2;
            mysql_query("UPDATE `users` SET `d` = `d` + '{$params['add']['count']}', `d` = `d` + '".($params['add']['count'] * 0.1)."' WHERE `id` = '{$params['add']['user_id']}'");
            mysql_query("INSERT INTO `payments` (`user`, `amount`, `time`) VALUES ('{$params["add"]["user_id"]}', '{$params["amount"]}', '".time()."')");
        }
        // возврат успешной обработки
        echo $wapkassa->successPayment();
    }
} catch (Exception $e) {
    // вывод ошибки
    echo 'Ошибка: ' . $e->getMessage() . PHP_EOL;
}